package net.t2code.opsecurity.check;

import com.sun.org.apache.xerces.internal.xs.StringList;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.language.Language;
import net.t2code.opsecurity.config.opWhitelist.OPWhitelist;
import net.t2code.opsecurity.events.Events;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.BungeeSenderReceiver;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.commands.T2Ccmd;
import net.t2code.t2codelib.SPIGOT.api.debug.T2Cdebug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.entity.Player;

import java.util.List;
import java.util.Map;

public class OpCheck {
    public static Boolean onCheck(Player player, Boolean join, String debug) {
        if (!(boolean) OPWhitelist.VALUES.enable.getValue()) return false;
        if (!player.isOp()) return false;
        if (opWhitelist(player, debug)) return false;
        if (join) T2Csend.console(Language.opWhitelistNotifyOnJoin.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
        Bukkit.getScheduler().runTask(Main.getPlugin(), new Runnable() {
            @Override
            public void run() {
                execute(player, join, debug);
            }
        });
        return true;
    }

    private static void execute(Player player, Boolean join, String debug) {
        if ((boolean)Config.VALUES.notifyJoinWarning.getValue() && join) {
            if ((boolean)Config.VALUES.notifyBungee.getValue()) {
                BungeeSenderReceiver.sendToBungee(Language.opWhitelistNotifyOnJoin.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
            } else
                Events.notifyPlayer(Language.opWhitelistNotifyOnJoin.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
        }

        if ((boolean)OPWhitelist.VALUES.noOpPlayerSetGameModeEnable.getValue()) {
            player.setGameMode(GameMode.valueOf( OPWhitelist.VALUES.noOpPlayerSetGameModeValue.getValue().toString()));
        }

        if ((boolean)OPWhitelist.VALUES.noOpPlayerDeopEnable.getValue()) {
            player.setOp(false);
            if ((boolean)OPWhitelist.VALUES.noOpPlayerKickEnable.getValue()) {
                if (!(boolean)OPWhitelist.VALUES.customCommandsEnable.getValue()) {
                    if ((boolean) Config.VALUES.kickCustomCommand.getValue()) {
                        T2Ccmd.console( Config.VALUES.kickCommand.getValue().toString().replace("[player]", player.getName()).replace("[reason]",
                                (boolean)OPWhitelist.VALUES.noOpPlayerKickEnable.getValue() && (boolean)OPWhitelist.VALUES.noOpPlayerDeopEnable.getValue() && (boolean)OPWhitelist.VALUES.noOpPlayerDeopPlayerSendMessage.getValue()
                                        ? Language.opWhitelistKick.value + "<br> <br>" + Language.opWhitelistDeop.value : Language.opWhitelistKick.value));
                    } else player.kickPlayer((boolean)OPWhitelist.VALUES.noOpPlayerDeopEnable.getValue() && (boolean)OPWhitelist.VALUES.noOpPlayerDeopPlayerSendMessage.getValue()
                            ? Language.opWhitelistKick.value + "\n \n" + Language.opWhitelistDeop.value : Language.opWhitelistKick.value);
                }
                T2Csend.console("["+debug+ "]" +Language.opWhitelistNotifyDeop.value.replace("[player]", player.getName().replace("[uuid]", String.valueOf(player.getUniqueId()))) + "<br>"
                        + Language.opWhitelistNotifyKick.value.replace("[player]", player.getName().replace("[uuid]", String.valueOf(player.getUniqueId()))).replace("[uuid]", String.valueOf(player.getUniqueId())));
                Events.notifyPlayer(Language.opWhitelistNotifyDeop.value.replace("[player]", player.getName()) + "<br>"
                        + Language.opWhitelistNotifyKick.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
            } else {
                T2Csend.console("["+debug+ "]" +Language.opWhitelistNotifyDeop.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
                Events.notifyPlayer(Language.opWhitelistNotifyDeop.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));

                if ((boolean)OPWhitelist.VALUES.noOpPlayerDeopPlayerSendMessage.getValue()) {
                    Bukkit.getScheduler().runTaskLater(Main.getPlugin(), new Runnable() {
                        @Override
                        public void run() {
                            T2Csend.player(player, Language.opWhitelistDeop.value);
                        }
                    }, 5L);
                }
            }
        }
        if ((boolean)OPWhitelist.VALUES.noOpPlayerKickEnable.getValue()) {
            if (!(boolean)OPWhitelist.VALUES.noOpPlayerDeopEnable.getValue()) {
                if (!(boolean)OPWhitelist.VALUES.customCommandsEnable.getValue()) {
                    if ((boolean)Config.VALUES.kickCustomCommand.getValue()) {
                        T2Ccmd.console(Config.VALUES.kickCommand.getValue().toString().replace("[player]", player.getName()).replace("[reason]", Language.opWhitelistKick.value));
                    } else player.kickPlayer(Language.opWhitelistKick.value);
                }
                T2Csend.console("["+debug+ "]" +Language.opWhitelistNotifyKick.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
                Events.notifyPlayer(Language.opWhitelistNotifyKick.value.replace("[player]", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
            }
        }
        if ((boolean)OPWhitelist.VALUES.customCommandsEnable.getValue()) {
            for (String cmd : (StringList)OPWhitelist.VALUES.customCommandsCommands.getValue()) {
                T2Ccmd.console(cmd.replace("[player]", player.getName()));
            }
        }
    }

    public static Boolean opWhitelist(Player player, String debug) {
        for (Map.Entry<String, PlayerObject> playerObject : PlayerCache.getOpHashMap().entrySet()) {
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] --------- " + player.getName()+" ---------");
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] opWhitelist playerObject Name: " + playerObject.getValue().playerName);
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] opWhitelist Player Name: " + player.getName());
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] opWhitelist playerObject UUID: " + playerObject.getValue().uuid);
            T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] opWhitelist Player UUID: " + player.getUniqueId().toString().replace("-", ""));
            if (playerObject.getValue().playerName.equals(player.getName()) && playerObject.getValue().uuid.equals(player.getUniqueId().toString().replace("-", ""))) {
                T2Cdebug.debug(Main.getPlugin(), "[" + debug + "] opWhitelist Player on list!");
                T2Cdebug.debug(Main.getPlugin(),"");
                return true;
            } else T2Cdebug.debug(Main.getPlugin(),"");
        }
        return false;
    }
}
