// This class was created by JaTiTV.

package net.t2code.opsecurity.config.opWhitelist;

import net.t2code.opsecurity.Util;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2CconfigWriter;
import net.t2code.t2codelib.T2CconfigItem;
import org.bukkit.GameMode;
import org.bukkit.configuration.ConfigurationSection;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class OPWhitelist {

    public enum VALUES implements T2CconfigItem {

        enable("opWhitelist.enable", false, true),
        playerMustBeOnlineToOp("opWhitelist.playerMustBeOnlineToOp", true, true),
        noOpPlayerDeopEnable("opWhitelist.noOpPlayerDeop.enable", true, true),
        noOpPlayerDeopPlayerSendMessage("opWhitelist.noOpPlayerDeop.playerSendMessage", true, true),
        noOpPlayerKickEnable("opWhitelist.noOpPlayerKick.enable", true, true),
        noOpPlayerSetGameModeEnable("opWhitelist.noOpPlayerSetGameMode.enable", true, true),
        noOpPlayerSetGameModeValue("opWhitelist.noOpPlayerSetGameMode.gameMode", GameMode.SURVIVAL, true),
        customCommandsEnable("opWhitelist.customCommands.enable", false, true),
        customCommandsCommands("opWhitelist.customCommands.commands", Arrays.asList("kick [player] &4You have op but are not authorized to do so, that's why you were kicked!"), true),

        playerSection("opWhitelist.whitelist", null, true),
        player1name("opWhitelist.whitelist.player1.name", "player1", false),
        player1uuid("opWhitelist.whitelist.player1.uuid", "00000000000000000000000000000000", false),
        player2name("opWhitelist.whitelist.player2.name", "player2", false),
        player2uuid("opWhitelist.whitelist.player2.uuid", "00000000000000000000000000000000", false),

        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final List<String> comments;

        VALUES(String path, Object value, boolean forceSet, String... comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = new ArrayList<>(Arrays.asList(comments));
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public List<String> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set() {
        long long_ = System.currentTimeMillis();
        T2CconfigWriter.createConfig(new File(Main.getPath(), "opWhitelist.yml"), VALUES.values(), Util.getConfigLogo());
        player();

        T2Ctemplate.onStartMsg(Util.getPrefix(), "§2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }


    private static void player() {
        ConfigurationSection section = (ConfigurationSection) VALUES.playerSection.getValue();
        for (String key : section.getConfigurationSection("").getKeys(false)) {
            String name = section.getString(key + ".name");
            PlayerObject playerObject = new PlayerObject(
                    name,
                    section.getString(key + ".uuid").replace("-", ""));
            PlayerCache.getOpHashMap().put(name, playerObject);
        }
    }
}
